/* I2C test program that writes & reads data to an I2C EEPROM device. */
/* 4 Nov 06													
	- added 1us delay after CSEL deassert 
	- verified that core control register writes work
*/

/* 8 Nov 06 */
/*	- Added Read routine for debug */

/* 11 Nov 06 */
/*	- verified program data written on for at least first 20-30 words
	- something dodgy with the calc of SinW0 - bodes poorly for A and B parms! */

/* 12 Nov 06 */
/*	- Fixed bug in Sin and Cos function
	- Made SinW0 and CosW0 local variables to filter coeff function - 
	  fuck knows why this was needed.. */
/* Correction to Fl and Fh for filter parm calcs */

/* 12 Nov 06 */
/* initial fix to delay setting calcs */
/* BW6 filter vauely functions, B12 and LR24 oscillate... */


/* 16 Nov 06 */
/* Changed sign of A1 and A2. Fixed oscillation. 			*/
/* AD system uses these with sign changed... 				*/
/* Also Need to fix 						  				*/
/* 			delay implementation 			  				*/
/*			attenuation implementation        				*/
/* Corrected Delay step size - minimum allowed is 1 unit 	*/

/* 25 Nov 06 */
/* Fix Write DAC Atten - this was rubbish...			 	*/

/* 29/1/07													*/
/* Fix bug attenuation for bands (had +6dB gain)			*/


/* 17 feb 07 												*/
/*	moved band 1 - 2 so connectors on rear panel work as expect */

/* 11 Jun 07 												*/
/*	bug fix 2007 make Atten unsigned char 					*/

/* 11 Jun 07 												*/
/*	function write_SPI 										*/
/* changed delay before and after SCLK from 5 us to 1 us 	*/

/* 28/6/07													*/
/* End of build 1 of major rewrite to implement rotary ctrl */
/* basic functionality for:									*/
/*	- Load and save three parm sets							*/
/*	- Rotary control basics									*/
/*	- Memory map for load save								*/
/*	- menu structure for rotary control						*/

/* Build currently excludes									*/
/*	- Parametric EQ											*/
/*	- NO Optimisation - this is a pretty simplistic 		*/
/*		implementation										*/

/* 18/7/07													*/
/* Add High Shelf and Peaking filters						*/



#include <p18f4520.h>
#include "delay.h"
#include "dig_cross.h"
#include "hex_program_data.h"
#include "Dig_Cross_EEPROM_Init.h"
#include "AD1940_Parm_Map.h"
#include <math.h>

/* Make this global to this function to save RAM */
int Data_Counter = 0;
double Alpha;
double W0;
double A0, IIR_B0_B1_B2_A1_A2[5];
double TempB0, TempB1;
long int Fixed_Point;



/* make this a function, as we need to use a single safeload write function...*/
long int FloatToFixed (double Float_No)
{
long int Fixed_No;


if (Float_No < 0)  				
	{									/* Integer part is float *1^ 23  */
	Fixed_No = -1*(long int)(Float_No * 0x800000);
	Fixed_No = 0x10000000 - Fixed_No;
	}
else
	{									/* Integer part is float *1^ 23  */
	Fixed_No = (long int)(Float_No *  0x800000);
	}
Fixed_No = Fixed_No &0x0FFFFFFF;
return Fixed_No;
}



/****************************************************************************************/
/* this will be done a few times - less RAM to make this a function call				*/
/* This assumes that CSEL is already active 											*/
/****************************************************************************************/
void WriteSPI(long int Data_Word, char bits)
{
unsigned long int Bit_Counter;

    Bit_Counter = ((unsigned long int)1<<(bits-1));		/* start at highest bit */

	for (Data_Counter = bits; Data_Counter > 0; Data_Counter--)
		{ 
		SClkLow;  						/* Set Clock bit Low  */
		if (Bit_Counter & Data_Word)
			PORTC = PORTC | (SDI_Out);      /* Set Data Bit High  */
		else
			PORTC = PORTC & (~SDI_Out);
	
		Bit_Counter = Bit_Counter >> 1;		/* Crank bit to outpu8t down one place */

		SClkHigh;         				/* Set Clock bit High  */
		DelayUs(1);
		}
}





/* this is in fact debug code - delete as needed*/
/* This does NOT assume that CSEL is already active */
/* fills data for bytes Read_Bytes to 0 */
/* MSB is in Read_Byte of array, LSB is in word 0 */
//void ReadSPI(char *Data_Read, int Read_Address, char Read_Bytes)
//{
//
//	CselLow;  									/* Set CSEL Low */
//	Write_SPI_Addr((char)0X00, Read_From_SPI);  	/* Address the AD1940 in READ mode*/
//	Write_16_Bits(Read_Address);				/* Provide the address of the AD1940 Core Control register */
//
//
//	for (counter = 0; counter < Read_Bytes ; counter++)
//		{
//
//		(*(Data_Read + counter)) = 0;
//		for (Data_Counter = 0; Data_Counter < 8; Data_Counter++)
//			{ 
//			SClkLow;  						/* Set Clock bit Low  */
//			DelayUs(5);
//											/*shift current data left one bit */
//			(*(Data_Read + counter)) = (*(Data_Read + counter)) * 2;
//			SClkHigh;         				/* Set Clock bit High  */
//			DelayUs(20);					/* pause for a tiny time */
//			if (SDI_In == 0x01) 					
//				*(Data_Read + counter) = *(Data_Read + counter)+1;       /* Set bit 0 High if AD1940 serial output is "1" */
//			else;
//			}
//
//		}
//	CselHigh;  			 	 				/* Set CSEL High */
//}




/* this will be done a few times - less RAM to make this a function call*/
void AD1940_Core_Ctrl(int Value)
{

CselLow;  														/* Set CSEL Low */
	Write_SPI_Addr((char)0X00, Write_To_SPI);   				/* Address the AD1940 */
	Write_16_Bits(AD1940_Core_Control_Address);							/* Provide the address of the AD1940 Core Control register */
	Write_16_Bits(Value);										/* Write Data data */
CselHigh;  					 		 							/* Set CSEL High */
}



/* this will be done a few times - less RAM to make this a function call*/
void SafeLoad_Write_Atten(int Address, long int Data)
{

CselLow;  														/* Set CSEL Low */
	Write_SPI_Addr((char)0X00, Write_To_SPI);   				/* Address the AD1940 */
	Write_16_Bits(AD1940_Safeload_Base_Address);				/* Provide the address of the indirect safeload address register */
	Write_16_Bits(Address);										/* Provide the destination address for the data */
CselHigh;  					 		 							/* Set CSEL High */

CselLow;  					 			/* Set CSEL Low */
	Write_SPI_Addr((char)0X00, Write_To_SPI);   		 		/* Address the AD1940 */
	Write_16_Bits(AD1940_Safeload_Base_Parameter);				/* Provide the address of the indirect safeload parameter register */
	Write_8_Bits(Attenuator_Slew_Type);										    /* First Byte sets the slew type for attenuation */
	Write_32_Bits(Data);										/* Write data to the AD1940 */
CselHigh;								/* Set CSEL High */
}




/* this will be done a few times - less RAM to make this a function call*/
void SafeLoad_Write_Parm(int Address, long int Data, char offset)
{

CselLow;  														/* Set CSEL Low */
	Write_SPI_Addr((char)0X00, Write_To_SPI);   				/* Address the AD1940 */
	Write_16_Bits(AD1940_Safeload_Base_Address + offset);		/* Provide the address of the indirect safeload address register */
	Write_16_Bits(Address);										/* Provide the destination address for the data */
CselHigh;  					 		 							/* Set CSEL High */

CselLow;  					 			/* Set CSEL Low */
	Write_SPI_Addr((char)0X00, Write_To_SPI);   		 		/* Address the AD1940 */
	Write_16_Bits(AD1940_Safeload_Base_Parameter + offset);		/* Provide the address of the indirect safeload parameter register */
	Write_8_Bits(0);										    /* Write one byte of 0 - first byts for parameters is 0 */
	Write_32_Bits(Data);										/* Write data to the AD1940 */
CselHigh;								/* Set CSEL High */
}






/* 
this function is to do the following:
-0- Init registers for configuration of DSP board as built
	- Check source of A/D input (this might in fact be from elsewhere!)
	- AD1938
		- Global Address = 0X04
			- Bits 23:17 = Address
			- Bit 16 = R/W_L
			- Bits 15:8 = Reg Address
			- Bits 7:0 = Data
		- Set BC Block Status (default = OFF)
		- Hold RESET line active (low) until things settle down
		- WAIT for 256 * MCLK after reset before doing anything! This is about 20uS.
		- PLL_Clock_CTRL_0  : Address = 0X00	: Data = 0x80
		- PLL_Clock_CTRL_1	: Address = 0X01	: Data = 0x00
		- DAC_CTRL_0		: Address = 0X02	: Data = 0x00
		- DAC_CTRL_1		: Address = 0X03	: Data = 0x00
		- DAC_CTRL_2		: Address = 0X04	: Data = 0x00
		- DAC_Channel_Mutes	: Address = 0X05	: Data = 0x00
		- Channel_Att_Ctrls	: Address = 0X06 to 0X0D : Data = 0x00
		- ADC_Control_0 	: Address = 0X0E	: Data = 0x02 or 0x00 (only DC Block)
		- ADC_Control_1		: Address = 0XF		: Data = 0x00
		- ADC_Control_2		: Address = 0X10	: Data = 0x48
		- Set ADC and DAC into SLAVE mode
*/
/*	- AD1940
		- Hold RESET line active (low) until things settle down
		- WAIT for 256 * MCLK after reset before doing anything! This is about 20uS.
		- Core_Control
			- Address = 0X0A52
			- Data = 0x000  (Need to set bit 9 HIGH to allow operation)  
							(Set bit 6 HIGH to clear registers after prog)
		- Parameter RAM Base Addreess: 0X000
		- Program RAM Base Addreess: 0X400
		- Slew RAM Base Addreess: 0XA00
		- Parameter RAM Safeload Registers Base Addreess: 0XA40
		- Parameter RAM Indirect Address Safeload Registers Base Addreess: 0XA45
*/
/*-then-
	- Copy Program from PIC ROM to DSP RAM by
	- Set Core_Control bit 9
	- Set Core_Control bit 6
	- Copy Program 
	- This function will not set the Parameters - they come from calculations for the XO points
	- Leave bit 9 of Core_Ctrl register set HIGH

*/
void Init_DSP(void)
{
long int Temp_Data;
int counter;

/* Wait about 100mS for things to settle down in the DSP - RESET is low at this point - refer init I/O */
DelayMs(100); 

CselHigh;  
ClearDSPReset;										/* set Reset_DSP high now - i.e. clear RESET - allow things to run*/
/* Wait about 100mS for things to settle down in the DSP - RESET is low at this point - refer init I/O */
DelayMs(100); 
CselLow;  
													/* Set up the CODEC */
													/* PLL_Clock_CTRL_0  : Address = 0X00	: Data = 0x80 */

Temp_Data = 0x080080;
CselLow; 						 					/* Set CSEL Low */
	WriteSPI(Temp_Data, 24);
CselHigh;  											/* Set CSEL high */

													/* ADC_Control_2		: Address = 0X10	: Data = 0xC8 */
Temp_Data = 0x0810C8;
CselLow; 						 					/* Set CSEL Low */
	WriteSPI(Temp_Data, 24);
CselHigh;  											/* Set CSEL high */


AD1940_Core_Ctrl((int)0x0040);						/* Set Core control to 0x0040 - bit 9 low, bit 6 high*/
DelayUs(10);
													/* now load the program */
CselLow;  											/* Set CSEL Low */
	Write_SPI_Addr((char)0X00, Write_To_SPI);    	/* Address the AD1940 */
	Write_16_Bits(AD1940_Program_Base);          	/* Provide the address of the base of program data */
											  		/* And now do a burst transfer for all program data */
	for(counter = 0; counter < progsize; counter++)
		{
		Write_8_Bits(ProgDat[counter]);
		}
	while(counter < Maxprogsize)					/* Now fill the rest of the memory with null words */
		{
		Write_8_Bits(0);
		Write_8_Bits(0);
		Write_8_Bits(0);
		Write_8_Bits(0);
		Write_8_Bits(1);
		counter++;
		}
CselHigh;         									/* Set CSel bit High  */



										
	 												/* Zeroise data by asserting bit 7 along with bit 6 */
AD1940_Core_Ctrl((int)0x00C0);						/* Set Core control to 0x00C0 - bit 9 low, bit 7 and 6 high*/

DelayUs(100);										/* then wait 100us */ 

														/* write DC block Parameters */
SafeLoad_Write_Parm(DCBlockAlg1pole_1,  DCBlockAlg1pole_1_Val,0);
AD1940_Core_Ctrl((int)0x0050);	
SafeLoad_Write_Parm(DCBlockAlg2pole_2,  DCBlockAlg2pole_2_Val,0);
AD1940_Core_Ctrl((int)0x0050);						/* Toggle safeload bit */
													/* Set Core control to 0x00D0 -> 
													bit 9 low keeps DSP stopped, bit 4 initiates safeload  
													bit 6 keeps data halted*/


}



/*
Write_Filter_Parm() takes a given Band, Frequency, XO type, Sample Rate and programs the DSP for this
	- For safeload leave bit 9 and 6 as is
	- Program Parameters using SAFELOAD registers
	- Set Bit 4 of Core_Ctrl high - clears itself - initialtes transfer of safeload parameters to parameter RAM

Band:
	- 0X00 bands 0 Upper Frequency
	- 0X01 bands 1 Upper Frequency
	- 0X02 bands 2 Upper Frequency
	- 0X03 bands 3 Upper Frequency
	- 0X10 bands 0 Lower Frequency
	- 0X11 bands 1 Lower Frequency
	- 0X12 bands 2 Lower Frequency
	- 0X13 bands 3 Lower Frequency
Frequency 
	- long int, value in Hz
XO Type
	- 0X00 = No filter	
	- 0X01 = 6dB Buttterworth	
	- 0X02 = 12dB Butterworth	
	- 0X03 = 24dB LR
	- 0X10 = No Filter
	- 0X11 = Peaking (Para EQ)
	- 0X12 = High Shelf
	
Q
	- Q for peaking and High Shelf

Filter_Gain
	- Gain for Peaking and high Shelf filters

Sample_Rate
	- unsigned int, value in samples per second
*/
void Write_Filter_Parm(unsigned char band, unsigned int Frequency, unsigned char XO_Type,  unsigned int Sample_Rate, char Q, char Filter_Gain)
{
int Temp_Address1, Temp_Address2;
int counter;
double SinW0, CosW0;
double Gain_A, Alpha_on_A, Alpha_by_A, A_Plus_1, A_Minus_1, SQRT_2_A;


/* Filter_Gain is the peaking gain or high shelf gain parameter */
/* this value of "A" - gain for these filters ia 10^(boos/40)   */
/* go figure...  what a bastard of a value. 					*/


if (Filter_Gain <= 0)
{
	Gain_A = ((float)(Atten_Shift_Para[-Filter_Gain]))/255.0;
}
else
{
	Gain_A = 255.0/((float)Atten_Shift_Para[Filter_Gain]);
}

/* W0 = 2*pi*f0/Fs */
W0 = 2 * Pi * (double)Frequency / (double)Sample_Rate;

/* Calculate SinW0 and CosW0  - this is cheaper on memory than the library routine in the compiler...*/
/*  Real fASqr = fAngle*fAngle;
    Real fResult = -2.39e-08f;
    fResult *= fASqr;
    fResult += 2.7526e-06f;
    fResult *= fASqr;
    fResult -= 1.98409e-04f;
    fResult *= fASqr;
    fResult += 8.3333315e-03f;
    fResult *= fASqr;
    fResult -= 1.666666664e-01f;
    fResult *= fASqr;
    fResult += 1.0f;
    fResult *= fAngle; */

	A0 = W0*W0;   /* borrow A0 */
	SinW0 = -2.39e-8;
	SinW0 = SinW0 * A0;
	SinW0 = SinW0 + 2.7526e-6;
    SinW0 = SinW0 * A0;
    SinW0 = SinW0 - 1.98409e-4;
    SinW0 = SinW0 * A0;
    SinW0 = SinW0 + 8.3333315e-3;
    SinW0 = SinW0 * A0;
    SinW0 = SinW0 - 1.666666664e-1;
    SinW0 = SinW0 * A0;
    SinW0 = SinW0 + 1.0;
    SinW0 = SinW0 * W0;


/*  Real fASqr = fAngle*fAngle;
    Real fResult = -2.605e-07f;
    fResult *= fASqr;
    fResult += 2.47609e-05f;
    fResult *= fASqr;
    fResult -= 1.3888397e-03f;
    fResult *= fASqr;
    fResult += 4.16666418e-02f;
    fResult *= fASqr;
    fResult -= 4.999999963e-01f;
    fResult *= fASqr;
    fResult += 1.0f;  */

	CosW0 = (float)-2.605e-7;
	CosW0 *= A0;
	CosW0 += (float) 2.47609e-5;
	CosW0 *= A0;
	CosW0 -= (float) 1.3888397e-3;
	CosW0 *= A0;
	CosW0 += (float) 4.16666418e-2;
	CosW0 *= A0;
	CosW0 -= (float) 4.999999963e-1;
	CosW0 *= A0;
	CosW0 += (float) 1.0;

Alpha = 0;
/* Case of NO filter "none" */
if ((XO_Type == 0) || (XO_Type == 0X10))
	{
	/* If want no filter set B0 = 1, rest = 0 */
	A0 = 0;
	A1 = 0;
	A2 = 0;
	B0 = 1;
	B1 = 0;
	B2 = 0;
	}
/* Case of 6dB filter */
else if (XO_Type == 1)
	{
	/* Low Pass
		a1 =  2.7^-?0
		b0 =  gainLinear * (1.0 - a1)
		b1 =  0   */
	/* High Pass
		a1 =  2.7^-?0
		b0 =  gainLinear * a1
		b1 = -a1 * gainLinear  */	
	A0 = 1;
	/* Algorithm to calculate e power w0) .... 	A1 = pow(2.7, -W0); */
	counter = 1;
	B0 = 1;							/* borrow B0 for a while - use this to calculate X^n - real value stuck in later*/
	B1 = 1;							/* borrow B1 for a while - use this to calculate n! - real value stuck in later*/
	A1 = 1;  						/* first term */
	do								/* This is essentially a taylor series expansion of e ^ -W0 */
		{
		B0 = -B0 * W0;
		B1 = B1 * counter;
		A1 = A1 + B0/B1;
		counter++;
		}
	while (counter < 10);
	A2 = 0;							/* B0 and B1 are always initialised in the following if -- else */
	B2 = 0;	
	if (band < 8)
		{
		B0 = 1 - A1;
		B1 = 0;
		}
	else
		{
		B0 = A1;
		B1 = -A1;
		}
	}
else if ((XO_Type == 2) || (XO_Type == 3))
	{
	/*Butterworth LP and HP  alpha = sin(?0) / 2.0 * 1/sqrt(2) */	
	Alpha =  SinW0/sqrt2;
	/* these are the same for both LP and HP */
	A0 = 1 + Alpha;
	A1 = (2*CosW0)/A0;
	A2 = (Alpha-1)/A0;
	if (band < 8)
		{
		/*	a0 =   1 + alpha
			a1 =  -2*cos(?0)
			a2 =   1 - alpha
			b0 =  (1 - cos(w0)) * gainLinear / 2
			b1 =   1 - cos(w0)  * gainLinear
			b2 =  (1 - cos(?0)) * gainLinear / 2  */
		B1 = (1 - CosW0)/(A0);
		B0 = B1/2;
		B2 = B0;
		}
	else
		{
		B1 = -(1 + CosW0)/(A0);
		B0 = -B1/2;
		B2 = B0;
		}
	}

else if (XO_Type == 0x11)
	{
	/*Peaking - Parametric EQ Filter*/	
	/* Remember that Q is in units of Q*10 */
	Alpha =  SinW0/(2.0 * (double)Q / 10.0);

	Alpha_on_A = Alpha / Gain_A;  
	Alpha_by_A = Alpha * Gain_A;

	/* these are the same for both LP and HP */
	A0 = 1 + Alpha_on_A;
	A1 = (2*CosW0)/A0;
	A2 = (Alpha_on_A - 1)/A0;

	B0 = (1 + Alpha_by_A)/A0;
	B1 = -(2* CosW0)/(A0);
	B2 = (1 - Alpha_by_A)/A0;;
	}

else if (XO_Type == 0x12)
	{
	/* High Shelf - CD Horn Correction*/	
	/* Q of 0.7 and S = 1 degenerates to the following */
	Alpha =  SinW0/sqrt2;

	/* These values for A+1 and A-1 are for A = 15dB */
	A_Plus_1 = 3.371373706;
	Gain_A = 2.371373706;
	A_Minus_1 = 1.371373706;
	SQRT_2_A = 2.177785;
	
	/* Coeficients for the High Shelf Filter */
	A0 = A_Plus_1 - A_Minus_1*CosW0 + SQRT_2_A*SinW0;
	A1 = -2*(A_Minus_1 - A_Plus_1*CosW0)/A0;
	A2 = -(A_Plus_1 - A_Minus_1*CosW0 - SQRT_2_A*SinW0)/A0;

	B0 = Gain_A * (A_Plus_1 + A_Minus_1*CosW0 + SQRT_2_A*SinW0)/A0;
	B1 = -2*Gain_A *(A_Minus_1 + A_Plus_1*CosW0)/A0;
	B2 = Gain_A * (A_Plus_1 + A_Minus_1*CosW0 - SQRT_2_A*SinW0)/A0;
	}

else;

if (XO_Type < 0x10)   /* Then we are programming the XO filters */
{
										/* char Filter_Map[4][2][2][5] */ 
										/* [Band] [Fh, Fl] [Filter1, Filter2] [b0, b1, b2, a1, a2] */
										/* void(int Address, double Data, char offset)  */
										/* Safeload Parameters */
										/* Write the 5 words to the safeload registers*/
	Temp_Address1 = band & 0x03;		/* do this to save instructions */
	Temp_Address2 = (band & 0x10) >> 4;	/* do this to save instructions */

	for (counter = 0; counter <= 4; counter++)
	{
		SafeLoad_Write_Parm(AD1940_Parm_Base + Filter_Map[Temp_Address1][Temp_Address2][0][counter], FloatToFixed(IIR_B0_B1_B2_A1_A2[counter]), counter);
	}

										/* Toggle safeload bit */
	AD1940_Core_Ctrl((int)0x0210);		/* Set Core control to 0x0210 -> bit 9 keeps DSP running, bit 4 initiates safeload  */

	if (XO_Type <= 2)					/* Write second lot of parameters.... */
		{
			B0 = 1;
			B1 = 0;
			B2 = 0;
			A0 = 0;
			A1 = 0;
			A2 = 0;
		}

	for (counter = 0; counter <= 4; counter++)
	{
		SafeLoad_Write_Parm(AD1940_Parm_Base + Filter_Map[Temp_Address1][Temp_Address2][1][counter], FloatToFixed(IIR_B0_B1_B2_A1_A2[counter]), counter);
	}
}
else     /* Else we are programming the parametric filters */
{
	
	for (counter = 0; counter <= 4; counter++)
	{
		SafeLoad_Write_Parm(AD1940_Parm_Base + Para_Filter_Map[band][counter], FloatToFixed(IIR_B0_B1_B2_A1_A2[counter]), counter);
	}
	
}


									/* Toggle safeload bit */
AD1940_Core_Ctrl((int)0x0210);		/* Set Core control to 0x0210 -> bit 9 keeps DSP running, bit 4 initiates safeload  */


}




/*
Write_Atten() takes a given bands required attenuation and programs the DSP for this
	- For safeload leave bit 9 and 6 as is
	- Program Parameters using SAFELOAD registers
	- Set Bit 4 of Core_Ctrl high then low (initialte safeload transfer to parameter RAM)
Band:
	- 0X00 bands 0 
	- 0X01 bands 1
	- 0X02 bands 2
	- 0X03 bands 3
Attenuation:
	- unsigned char  (will need to check this one!!!)
*/
void Write_Atten(char band, unsigned char atten)
{
long int Atten_Calc;
long int Interim_Atten_Calc;
int Atten_Map[4] =  /* [Band]*/
{
	HWGain1940Alg41_20,  /* Band 2 */	
    HWGain1940Alg30_19,  /* Band 1 */
	HWGain1940Alg52_21,  /* Band 3 */
	HWGain1940Alg63_22   /* Band 4 */
};

/* 29/1/07													*/
/* Fix bug attenuation for bands (had +6dB gain)			*/
Atten_Calc = 0x008000;
Atten_Calc = (Atten_Calc << (8 - (atten/6)));
Interim_Atten_Calc = ((long int)Atten_Shift[atten % 6]);
Interim_Atten_Calc = Interim_Atten_Calc << 7;
Interim_Atten_Calc = Interim_Atten_Calc << (8 - atten/6);
Atten_Calc = Atten_Calc - Interim_Atten_Calc;
									/* Atten_Slew Rate constants - sets slew type */
Atten_Calc = Atten_Calc + Attenuator_Slew_Rate;
									/* safeload write parameters to AD1940 */
SafeLoad_Write_Atten(AD1940_Parm_Base + Atten_Map[band], Atten_Calc);
									/* Toggle safeload bit */
AD1940_Core_Ctrl((int)(AD1940_CC_Clear_Regs_L + AD1940_CC_Init_SafeTx_To_Target));		
		/* Set Core control to 0x0220 -> bit 9 keeps DSP running, bit 4 initiates safeload  */

}




/*
Write_Delay() takes a bands required delay and programs the DSP for this
	- set bit 9 of Core_Ctrl register set HIGH
	- Program Attenuation Parameter using SAFELOAD
	- Clear Bit 9

Band:
	- 0X00 bands 0 
	- 0X01 bands 1
	- 0X02 bands 2
	- 0X03 bands 3
Delay:
	- long int 
*/
void Write_Delay(unsigned char band, int Delay_mm, unsigned int Sample_Rate)
{
float Delay_Clocks;

Delay_Clocks = (float)Sample_Rate * (float)Delay_mm;
Delay_Clocks = Delay_Clocks / SpeedOfSound;

/* Dont let this be zero though */
if (Delay_Clocks < 1)
	Delay_Clocks = 1;

/* safeload write parameters to AD1940 */
SafeLoad_Write_Parm(AD1940_Parm_Base + Delay_Map[band][0], (int)Delay_Clocks, 0);

									/* Toggle safeload bit */
AD1940_Core_Ctrl((int)0x0210);		/* Set Core control to 0x0210 -> bit 9 keeps DSP running, bit 4 initiates safeload  */

									/* safeload write parameters to AD1940 */
SafeLoad_Write_Parm(AD1940_Parm_Base + Delay_Map[band][1],  (int)Delay_Clocks, 0);

									/* Toggle safeload bit */
AD1940_Core_Ctrl((int)0x0210);		/* Set Core control to 0x0210 -> bit 9 keeps DSP running, bit 4 initiates safeload  */

}


/*
Write_Dac_Atten() Sets attenuation for DAC.  This is essentially the volume Control
	- address 0x04 <<1 plus [read 1, write 0] -->  0x08
	- register addresses 6-13 for each of the 8 channels
	- atten value is 3/8 dB per step

bug fix 2007 make Atten unsigned char
*/

void Write_Dac_Atten(unsigned char Atten)
{
long int Temp_Counter;
long int Temp_Data;
long int Temp_Offset;

/* change 11/6/07 */
// Temp_Data = 0x080000 + (long int)Atten;
Temp_Data = 0x080000 + Atten;
									/* Write to DAC */

for (Temp_Counter = 6; Temp_Counter < 14; Temp_Counter++)
	{
		Temp_Offset = Temp_Counter * 256;		
		CselLow;  					/* Set CSEL Low */

			WriteSPI((Temp_Data + Temp_Offset), 24);
		CselHigh;  					/* Set CSEL high */
	}

}


