/* Digital Crossover Controller for AD1940. 								*/
/* 11/11/06 included delay at startup to allow AD1940 to settle 			*/
/* 12/11/06 verified that UpdateFilterSettings sends decent data to 
/* write filter parms  														*/

/* 16/11/06 																*/
/* Set delaymm step sizes TO +/- 3 AND +/- 33               				*/


/* 25/11/06 																*/
/* Delete Write Dac Atten 90, as DAC is intialised with DSP 				*/


/* 3/1/07 																	*/
/* Move DAC Attenuator write to immediately after DSP init  				*/
/* Fix bug with max volume immediately on boot up							*/
/* This is the baseline LED version - update only for bugs! 				*/

/* 5/1/07																	*/
/* Modify tio write to LCD 													*/

/* 9/1/07																	*/
/* Fix bug initialisation of volume at bootup 								*/

/* 29/1/07																	*/
/* Fix bug CD / Analogue input select detect 								*/

/* 28/6/07																	*/
/* End of build 1 of major rewrite to implement rotary ctrl 				*/
/* basic functionality for:
	- Load and save three parm sets
	- Rotary control basics
	- Memory map for load save
	- menu structure for rotary control
*/
/* Build currently excludes
	- Parametric EQ
	- NO Optimisation - this is a pretty simplistic implementatioN			*/


/* 30/06/07	vera															*/
/* More or less functional - not thoroughly tested							*/
/* but no known issues														*/

/* 30/06/07																	*/
/* Major retsructure to move display line building logic 					*/
/* into the display navigation state machine, as the current				*/
/* implementation more or less replicates the state machine 				*/
/* logic in the display generation code - seems stupid						*/
/*	START MOVING CODE */

/* 15/07/07	vera															*/
/* Code to handle Parametric EQ data and menu written and init tests		*/
/* Needs code to calculate IIR parameters, new DSP code and 				*/
/* to write Paremeters to the AD1940										*/

/* 22/07/07	vera															*/
/* Code efficiency improved in dig_cross.c by usig pointers rather than		*/
/* indexed array references in code							 				*/
/* Needs:																	*/
/* - CD Horn Correction code fixed											*/
/* - Check code in AD1940.c for efficiency gains							*/
/* - parameter addresses for new filters to be included in .h file			*/
/* - New DSP code to be loaded into .h file									*/


/* 31/07/07	vera															*/
/* Inserted new DSP code and showed runs - kind of							*/
/* Verified generates output  								 				*/
/* Known Bugs:																*/
/*	EQ data needs to be modified to properly initialise Para Coefficients 	*/
/* Needs:																	*/
/* - CD Horn Correction code validated										*/
/* - Check code in AD1940.c for efficiency gains							*/


/* 1/08/07	vera															*/
/* Inserted new DSP code and showed runs - kind of							*/
/* Verified generates output  								 				*/
/* known Issues:															*/
/*	Something with addressing or similar is wrong in parametric filters		*/
/*  You need to look at what you are doing with global variables			*/
/*  It might have been worth it in the 16F877, but it is shit practise		*/
/* Needs:																	*/
/* - CD Horn Correction code validated										*/
/* - Check code in AD1940.c for efficiency gains							*/

/* 6/08/07	vera															*/
/* Status Issues:															*/
/*					Parametric EQ Running									*/
/*					Shelving EQ running										*/
/* known Issues:															*/
/*  You need to look at what you are doing with global variables			*/
/*  It might have been worth it in the 16F877, but it is shit practise		*/

/* 16/08/07	version															*/
/* Status Issues:															*/
/*					Rotary control functioning								*/
/* known Issues:															*/
/*  You need to look at what you are doing with global variables			*/
/*  It might have been worth it in the 16F877, but it is shit practise		*/
/* Still need to move EQ types to start of EQ menu structure 				*/

/* 17/08/07	version															*/
/* Status Issues:															*/
/*					Rotary control functioning								*/
/*  You just changes the parametric EQ menu structure - TEST IT				*/
/* known Issues:															*/
/*  You need to look at what you are doing with global variables			*/
/*  It might have been worth it in the 16F877, but it is shit practise		*/
/* Still need to move EQ types to start of EQ menu structure 				*/

/* 19/08/07	version															*/
/* Status Issues:															*/
/* 																			*/
/* known Issues:															*/

/* 21/08/07	version ver E															*/
/* Status Issues:															*/
/*					Rotary control functioning								*/
/* 																			*/
/* known Issues:None														*/


#include <p18F4520.h>
#include <timers.h>
#include "delay.h"
#include "dig_cross.h"
#include "AD1940.h"

/* Do something gross - and define the data structure such 					*/
/* that it is globally accessible to this module							*/
/*  my excuse it that this allows me to avoid mucking 						*/
/* around with pointers etc  												*/

/* Delete me later please */
void timer_isr (void);
static unsigned char s_count = 0;
static unsigned char Old_Rot_Status = 0;  	/* Records state of rotary control */
static unsigned char Fast_Loop_Counter = 0; /* Used to set Fast_Cnt */
static unsigned char Slow_Loop_Counter = 0; /* Used to see if user turning control continuously */
static unsigned char Keypress_Read = 0;			/* this is the data on key / rotation changes */
static unsigned char Key_Just_Pressed = 0;  		/* use this to keep track of which keys have been pressed */
static unsigned char Fast_Change = 1;				/* use this to indicate fast change of values */


data_val_struct Data_Values[4];
data_val_struct *Data_Values_Pointer, *Temp_Data_Values_Pointer;
Para_EQ_struct EQ_Values[6];
Para_EQ_struct *EQ_Values_Pointer, *Temp_EQ_Values_Pointer;
char loop, test_temp;
char line1[] =   Line1_Init;
char line2[] =   Line2_Init;

/* These are ROM constants used in bnuilding the display 					*/
rom char Blank_Char = Blank_Char_Init;    								/* ROM */
rom char Sel_Str[] = Line2_Select_Init;    								/* ROM */
int display_temp;
rom char EQ_Str[] =  Line1_EQ_Init;    									/* ROM */
rom char XO_Str[] =  Line1_XO_Init;    									/* ROM */
rom char Save_Str[] =  Line1_Save_Init;									/* ROM */
rom char Load_Str[] =  Line1_Load_Init;									/* ROM */
rom char Choose_Str[] = Line1_Choose_Str_Init; 							/* ROM */
rom char Vol_Str[] = Line1_Vol_Init;									/* ROM */
rom char Slopes[4][4] = Slopes_Def_Init;							/* ROM */

rom char XO_Choice_Display[7][17] =
{
"XO -> Band:     ",
"Band X, Low Frq:",
"Band X, Hi Frq: ",
"Band X, Low XO: ",
"Band X, High XO:",
"Band X, Delay:  ",
"Band X, Atten:  "
};																	/* ROM */

rom char XO_Units_Display[6][6] =
{
"Hz   ",
"Hz   ",
"Slope",
"Slope",
"mm   ",
"dB   "
};																	/* ROM */

rom char Choice_Display[5][17] =
{
"Volume          ",
"Crossover       ",
"Save Parameters?",
"Load Parameters?",
"EQ Setup?       "
};																	/* ROM */


rom char EQ_Choice_Display[2][6] =
{
"Band ",
"Comm "
};																	/* ROM */

rom char EQ_Select_Display[4][12] =
{
"X, EQ Freq:",
"X, EQ Q:   ",
"X, EQ Gain:",
"X, EQ Type:"
};																	/* ROM */

rom char EQ_Units_Display[4][6] =
{
"Hz   ",
"     ",
"dB   ",
"     "
};																	/* ROM */

rom char EQ_Type_Display[4][11] =
{
"None      ",
"Parametric",
"CD Horn   "
};	

/****************************************************************************/
/* Initialise the PIC														*/
/****************************************************************************/

void Init_IO(void)
{

/* ADCON setup */
	ADCON0 = 0;				// A/D Port reconfiguration
	ADCON1 = 0x0f;			// A/D Port reconfiguration
	ADCON2 = 0;				// A/D Port reconfiguration

/* set up interrupts */
	PIE1 = 0;				// Disable interrupt 1
	PIE2 = 0;				// Disable interrupt 2
	INTCONbits.GIE = 0;		// Global interrupt disable


/* Refer to Dif Cross.h for definitions
* Port A = bit 0-4 Inputs
* Port B Output - character selects 
* Port C bits 4 and 6 Inputs
* Port D Output - mul	tiplexed leds
* Port E outputs `
*/
/* initialise IO */
	TRISA=0X1E;
	TRISB=0X00;
	TRISC=0X50;
	TRISD=0X00;
	TRISE=0x00;


/* disable CSEL */
PORTC = PORTC | (CSel);                    /* Set Clock bit High  */
/* Hold DSP in RESET */
PORTC = PORTC & (255 - Reset_DSP);         /* Hold DSP Reset Low  */
PORTB = 0;   
}



/****************************************************************************/
/* Do this in one place  -  save memory and hassles with consistency!    	*/
/****************************************************************************/
void Load_From_Memory(char Mem_Bank)
{
char BandTemp;

/* Read in the parameters for crossover points from default bank of EEPROM */
for (loop=0; loop < 4; loop++)
	{
											/* Use pointers to the data structures */
											/* as it is more code efficient */
	Data_Values_Pointer = &(Data_Values[loop]);
	EQ_Values_Pointer = &(EQ_Values[loop]);
											/* Read Data for each band from EEPROM */
	BandTemp = (loop * Band_Data_Array_Size) + (ParmSet_Array_Size * Mem_Bank);	
											/* Lower crossover Freq */
	Data_Values_Pointer->Fl = EEPROM_READ(BandTemp + Fl_Offset);						
	Data_Values_Pointer->Fl += EEPROM_READ(BandTemp + Fl_Offset + 1) * 256;
											/* Upper crossover Freq */
	Data_Values_Pointer->Fu = EEPROM_READ(BandTemp + Fu_Offset);						
	Data_Values_Pointer->Fu += EEPROM_READ(BandTemp + Fu_Offset + 1) * 256;
											/* Lower crossover Slope */
	Data_Values_Pointer->Sl = EEPROM_READ(BandTemp + Sl_Offset);
											/* Upper crossover Slope */
	Data_Values_Pointer->Su = EEPROM_READ(BandTemp + Su_Offset);
											/* Attenuation to be applied to band */
	Data_Values_Pointer->Atten = EEPROM_READ(BandTemp + Atten_Offset);
											/* Delay to be applied to band */
	Data_Values_Pointer->Delay_mm = EEPROM_READ(BandTemp + Delay_mm_Offset);
	Data_Values_Pointer->Delay_mm += EEPROM_READ(BandTemp + Delay_mm_Offset + 1) *256;
											/* Parametric EQ Centre Freq */
	EQ_Values_Pointer->CF = EEPROM_READ(BandTemp + Para_CF_Offset);			
	EQ_Values_Pointer->CF += EEPROM_READ(BandTemp + Para_CF_Offset + 1) *256;
											/* Parametric EQ Q Value */
	EQ_Values_Pointer->Q = EEPROM_READ(BandTemp + Para_Q_Offset);			
											/* Parametric EQ Gain */
	EQ_Values_Pointer->Gain = EEPROM_READ(BandTemp + Para_Gain_Offset);			
											/* Parametric EQ Type */
	EQ_Values_Pointer->Type = EEPROM_READ(BandTemp + Para_Type_Offset);			
	};


/* Read Data for each Para Set from EEPROM */
BandTemp = (Para_Gen_Base + Para_Parmset_Size * Mem_Bank);	

									/* Use pointers to the data structures */
									/* as it is more code efficient */
EQ_Values_Pointer = &(EQ_Values[Gen1_Para_data]);

/* Gen1 Parametric EQ Centre Freq */
EQ_Values_Pointer->CF = EEPROM_READ(BandTemp + Para_Gen1_CF_Offset);			
EQ_Values_Pointer->CF += EEPROM_READ(BandTemp + Para_Gen1_CF_Offset + 1) *256;
/* Gen1 Parametric EQ Q Value */
EQ_Values_Pointer->Q = EEPROM_READ(BandTemp + Para_Gen1_Q_Offset);			
/* Gen1 Parametric EQ Gain */
EQ_Values_Pointer->Gain = EEPROM_READ(BandTemp + Para_Gen1_Gain_Offset);			
/* Gen1 Parametric EQ Type */
EQ_Values_Pointer->Type = EEPROM_READ(BandTemp + Para_Gen1_Type_Offset);			

									/* Use pointers to the data structures */
									/* as it is more code efficient */
EQ_Values_Pointer = &(EQ_Values[Gen2_Para_data]);

/* Gen2 Parametric EQ Centre Freq */
EQ_Values_Pointer->CF = EEPROM_READ(BandTemp + Para_Gen2_CF_Offset);			
EQ_Values_Pointer->CF += EEPROM_READ(BandTemp + Para_Gen2_CF_Offset + 1) *256;
/* Gen1 Parametric EQ Q Value */
EQ_Values_Pointer->Q = EEPROM_READ(BandTemp + Para_Gen2_Q_Offset);			
/* Gen1 Parametric EQ Gain */
EQ_Values_Pointer->Gain = EEPROM_READ(BandTemp + Para_Gen2_Gain_Offset);			
/* Gen1 Parametric EQ Type */
EQ_Values_Pointer->Type = EEPROM_READ(BandTemp + Para_Gen2_Type_Offset);			
	

}



/************************************************************************/
/* 	Write Line 1 and Line 2 of LCD										*/
/************************************************************************/
void Update_LCD(void)
{

/* Set Line 1 Address */
PORTB = Write_Control_LCD;
PORTD = LCD_Line_1;
PORTB = Write_Control_Enable_LCD;
DelayUs(50);
PORTB = Write_Control_LCD;

DelayMs(2);

for (loop = 0; loop < 16; loop++)
	{
		/* Write string 1 to LCD */
		PORTB = Write_Data_Enable_LCD;
		PORTD = line1[loop];
		PORTB = Write_Data_LCD;
		DelayUs(50);
		PORTB = Write_Data_Enable_LCD;
	}


/* Set Line 2 Address */
PORTB = Write_Control_LCD;
PORTD = LCD_Line_2;
PORTB = Write_Control_Enable_LCD;
DelayUs(50);
PORTB = Write_Control_LCD;
DelayMs(4);


for (loop = 0; loop < 16; loop++)
	{
		/* Write string 2 to LCD */
		PORTB = Write_Data_Enable_LCD;
		PORTD = line2[loop];
		PORTB = Write_Data_LCD;
		DelayUs(50);
		PORTB = Write_Data_Enable_LCD;
	}	
	
}


/************************************************************************/
/* 						Init  											*/
/************************************************************************/
void Init_LCD(void)
{
/* Function Select */
PORTB = Write_Control_LCD;
PORTD = LCD_Function;
PORTB = Write_Control_Enable_LCD;
DelayUs(5);
PORTB = Write_Control_LCD;

DelayUs(40);

/* Display On */
PORTD = LCD_Display_On;
PORTB = Write_Control_Enable_LCD;
DelayUs(5);
PORTB = Write_Control_LCD;

DelayUs(40);

/* Display Clear */
PORTD = LCD_Display_Clear;
PORTB = Write_Control_Enable_LCD;
DelayUs(5);
PORTB = Write_Control_LCD;

DelayMs(2);

/* Entry Mode */
PORTD = LCD_Display_Entry_Mode;
PORTB = Write_Control_Enable_LCD;
DelayUs(5);
PORTB = Write_Control_LCD;

/* Display Clear */
PORTB = Write_Control_LCD;
PORTD = LCD_Display_Clear;
PORTB = Write_Control_Enable_LCD;
DelayUs(50);
PORTB = Write_Control_LCD;

DelayMs(2);
}




/************************************************************************/
/* 						Display relevant data on the LCD 			
Need to build display lies for:
Display_Fn = 
	Choosing_Fn	
	Volume_Mode
	XO_Mode 
	Save_Mode
	Load_Mode
	EQ_Mode
	Change_Mode															*/
/*
and the following explicit functions
	XO_Band_Sel_Fn
	XO_Parm_Sel
	XO_LF_Parm_Fn
	XO_HF_Parm_Fn
	XO_SL_Parm_Fn
	XO_SU_Parm_Fn
	XO_Del_Parm_Fn
	XO_Att_Parm_Fn

	Save_Sel_Fn

	Load_Sel_Fn															*/

/*
#define EQ_Sel_Fn 				
#define EQ_Freq_Sel_Fn 			
#define EQ_Q_Sel_Fn  	
#define EQ_Gain_Sel_Fn 	
#define EQ_Type_Sel_Fn 	
																		*/
/************************************************************************/
void Display_Data(char Display_Band, char Display_Fn, int Display_Value)
{
char loop;
int Display_Value_Temp;

/* Use this to remember if the Display Value needs a - sign */
Display_Value_Temp = Display_Value;
for (loop = 15; loop >= 0; loop--)
	{
	/* initialise the strings */
	line1[loop] = Blank_Char;
	line2[loop] = Blank_Char;


/********************************************************************/
/* 					Build Line 1 string in here 					*/
/********************************************************************/

/************************************************************************/
/* Choosing Value - user selecting the fuinction to modify 				*/
/************************************************************************/
	if (Display_Fn == Choosing_Fn)
		{
		line1[loop] = Choose_Str[loop];
		line2[loop] = Choice_Display[Display_Value - 1][loop];					
		}


/************************************************************************/
/* Volume Function - user modifying the volume 							*/
/************************************************************************/
	else if (Display_Fn == Vol_Sel_Fn)
		{
		/* Build string */
		line1[loop] = Vol_Str[loop];
		/* Convert integer to ASCII */
		/* Put volume in last three characters of line 1 */
		if (loop > 12)
			{
			display_temp = Display_Value % 10;
			line1[loop] = (display_temp)+48;  /* 48 is offset of "0" ASCII */
			Display_Value = Display_Value/10;
			}
		}

/************************************************************************/
/* Crossover band Select 					 							*/
/************************************************************************/
	else if (Display_Fn == XO_Band_Sel_Fn)
		{
		/* Build string */
		line1[loop] = XO_Str[loop];

		/* Convert 0-3 integer to 1-4 ASCII for band number */
		/* tweak this to make bands come up as 1 .. 4 */
		if (loop == 14) 
			line1[loop] = Display_Value + 49;
		}


/************************************************************************/
/* Crossover Parameter Selection for user to change						*/
/************************************************************************/
	else if (Display_Fn == XO_Parm_Sel)
		{
		/* Build string */
		line1[loop] = XO_Choice_Display[(Display_Value - XO_LF_Parm_Fn) + 1][loop];
		line2[loop] = Sel_Str[loop];
		/* Convert 0-3 integer to 1-4 ASCII for band number */
		/* tweak this to make bands come up as 1 .. 4 */
		if (loop == 5) 
			line1[loop] = Display_Band + 49;			
		}

/************************************************************************/
/*Crossover Parameter modification display								*/
/************************************************************************/
	else if ((Display_Fn >= XO_LF_Parm_Fn) && (Display_Fn <= XO_Att_Parm_Fn))
		{
		/* Build string */
		line1[loop] = XO_Choice_Display[(Display_Fn - XO_LF_Parm_Fn)+1][loop];

		/* Convert 0-3 integer to 1-4 ASCII for band number */
		/* tweak this to make bands come up as 1 .. 4 */
		if (loop == 5) 
			line1[loop] = Display_Band + 49;		

		/* For displays requiring numerical output, Convert integer to ASCII */
		if ((Display_Fn != XO_SL_Parm_Fn) && (Display_Fn != XO_SU_Parm_Fn))
			{
			if (loop <= 3)
				{
				display_temp = Display_Value % 10;
				if ((Display_Value > 0) || (loop == 3))
					line2[loop] = (display_temp)+48;
				else
					line2[loop] = Blank_Char;
		
				Display_Value = Display_Value/10;
				}
			/* put up units display for crossover parameters */
			if ((loop >= 5) && (loop < 10))
				line2[loop] = XO_Units_Display[Display_Fn - XO_LF_Parm_Fn][loop-5];
			}
			
			/* Else for displays requiring string put up const string...
			Now if the display is of the XO slope, put in the right string */
			if ((Display_Fn == XO_SL_Parm_Fn) || (Display_Fn == XO_SU_Parm_Fn))
				{
				if (loop <= 3)
					line2[loop] = Slopes[Display_Value][loop];
				}
		}


/************************************************************************/
/* Equaliser Selection - Band 1-4 and Common 1,2						*/
/************************************************************************/
	else if (Display_Fn == EQ_Sel_Fn)
		{
		/* Build string */
		if (loop < 10)
			line1[loop] = EQ_Str[loop];
		else 
			{
			if (Display_Value < 4)
				{
				line1[loop] = EQ_Choice_Display[0][loop - 10];
				if (loop == 15) line1[loop] = Display_Value+49;
				}
			else
				{
				line1[loop] = EQ_Choice_Display[1][loop - 10];
				if (loop == 15) line1[loop] = Display_Value-4+49;
				}
			}
		}


/************************************************************************/
/* Display EQualiser parameters, freq, Q, Gain and Type					*/
/************************************************************************/
	else if ((Display_Fn == EQ_Freq_Sel_Fn) || (Display_Fn == EQ_Q_Sel_Fn) || 
			 (Display_Fn == EQ_Gain_Sel_Fn) || (Display_Fn == EQ_Type_Sel_Fn))
		{
			/* Build string */
			if (loop < 5)
			{
				if (Display_Band < Gen1_Para_data)
					line1[loop] = EQ_Choice_Display[0][loop];
				else
					line1[loop] = EQ_Choice_Display[1][loop];
			}
			else
			line1[loop] = EQ_Select_Display[Display_Fn - EQ_Freq_Sel_Fn][loop - 5];


			
			if (loop == 5)
			{
				if (Display_Band < 4)
					{
					line1[loop] = Display_Band + 49;
					}
				else
					{
					line1[loop] = Display_Band + 49-4;
					}
			} 
			
			if ((Display_Fn == EQ_Type_Sel_Fn) && (loop < 10))
				line2[loop] = EQ_Type_Display[Display_Value][loop];
			
			if (Display_Value < 0)
				Display_Value = - Display_Value;

			if (Display_Fn != EQ_Type_Sel_Fn)
				if (loop < 5)
				{
					if((loop == 3) && (Display_Fn == EQ_Q_Sel_Fn))
						line2[loop] = 46;
					else
					{
						display_temp = Display_Value % 10;
						if ((Display_Value > 0) || (loop == 4))
							line2[loop] = (display_temp)+48;
						else
							line2[loop] = Blank_Char;
						Display_Value = Display_Value/10;
					}
				}
				else if ((loop > 5) && (loop < 11))
				{
					line2[loop] = EQ_Units_Display[Display_Fn - EQ_Freq_Sel_Fn][loop - 6];
				}
				
			if ((Display_Fn == EQ_Gain_Sel_Fn) && (loop == 2) && (Display_Value_Temp < 0))
			line2[loop] = 45;   /* - sign */
		}

/************************************************************************/
/* Save Function display												*/
/************************************************************************/
	else if (Display_Fn == Save_Sel_Fn)
		{
		/* Build string */
		line1[loop] = Save_Str[loop];
	
		/* Convert 0-3 integer to 1-3 ASCII for bank number */
		if (loop == 13) 
			line1[loop] = Display_Value + 49;
		}

/************************************************************************/
/*Load function display													*/
/************************************************************************/
	else if (Display_Fn == Load_Sel_Fn)
		{
		/* Build string */
		line1[loop] = Load_Str[loop];
			
		/* Convert 0-3 integer to 1-3 ASCII for bank number */
		if (loop == 15) 
			line1[loop] = Display_Value + 49;
		}

	}
	/************************************************************************/
	/* END of Loop to 16 													*/
	/************************************************************************/

Update_LCD();		/* Writes Line1 and Line2 Strings to LCD */
}






/* Call this to completely update all filter settings etc */
void Update_Filter_Set(unsigned int Sample_Rate)
{
char local_loop;	
	for (local_loop = 0; local_loop < 4; local_loop++)
	{
		Temp_Data_Values_Pointer = &Data_Values[local_loop];
	    Write_Filter_Parm(0x10 + local_loop, Temp_Data_Values_Pointer->Fl, Temp_Data_Values_Pointer->Sl, Sample_Rate,0 ,0); 
	    Write_Filter_Parm(0x00 + local_loop, Temp_Data_Values_Pointer->Fu, Temp_Data_Values_Pointer->Su, Sample_Rate,0 ,0); 
		Temp_EQ_Values_Pointer = &EQ_Values[local_loop];
	    Write_Filter_Parm(       local_loop, Temp_EQ_Values_Pointer->CF, (Temp_EQ_Values_Pointer->Type) + 0x10, Sample_Rate,Temp_EQ_Values_Pointer->Q ,Temp_EQ_Values_Pointer->Gain); 
	}
	Temp_EQ_Values_Pointer = &EQ_Values[Gen1_Para_data];
    Write_Filter_Parm(       Gen1_Para_data, Temp_EQ_Values_Pointer->CF, (Temp_EQ_Values_Pointer->Type) + 0x10, Sample_Rate,Temp_EQ_Values_Pointer->Q ,Temp_EQ_Values_Pointer->Gain); 
	Temp_EQ_Values_Pointer = &EQ_Values[Gen2_Para_data];
    Write_Filter_Parm(       Gen2_Para_data, Temp_EQ_Values_Pointer->CF, (Temp_EQ_Values_Pointer->Type) + 0x10, Sample_Rate,Temp_EQ_Values_Pointer->Q ,Temp_EQ_Values_Pointer->Gain); 
}


/* Call this to update all Atten settings etc */
void Update_Atten_Set()
{
	for (loop = 0; loop < 4; loop++)
	{
		Write_Atten(loop, Data_Values[loop].Atten);	
	}
}


/* Call this to update all Atten settings etc */
void Update_Delay_Set(unsigned int Sample_Rate)
{
	for (loop = 0; loop < 4; loop++)
	{
		Write_Delay(loop, Data_Values[loop].Delay_mm, Sample_Rate);	
	}
}



#pragma code low_vector=0x18
void low_interrupt (void)
{
	_asm GOTO timer_isr _endasm
}
#pragma code




/****************************************************************************/	
/* Uses the following globals 												*/
/* s_count 																	*/
/* Old_Rot_Status    Records state of rotary control 						*/
/* Fast_Loop_Counter  Used to set Fast_Cnt 									*/
/* Slow_Loop_Counter  Used to see if user turning control continuously 		*/
/*																			*/	
/*																			*/	
/* This sets is the ISR that deals with key presses etc						*/
/****************************************************************************/	
#pragma interruptlow timer_isr
void 
timer_isr (void)
{
	unsigned char Current_Rot_Status = 0;
	
	Current_Rot_Status = PORTA & (Vals_0 + Vals_1 + Exit + Sel);  /*Read Rot Status and mask off bits of interest */

	Key_Just_Pressed = (Current_Rot_Status != Old_Rot_Status);

	/* Only do this if something has changed */
	if (Key_Just_Pressed  && !(Current_Rot_Status & (Sel + Exit)))
	{
		if (Old_Rot_Status == Phase_0)  /* From here need to work out if going up or down */
		{
			if (Current_Rot_Status == Phase_1)
				Keypress_Read = Rot_Up;
			else
				Keypress_Read = Rot_Down;
		}
		else if (Old_Rot_Status == Phase_1)  /* From here need to work out if going up or down */
		{
			if (Current_Rot_Status == Phase_2)
				Keypress_Read = Rot_Up;
			else
				Keypress_Read = Rot_Down;			
		}
		else if (Old_Rot_Status == Phase_2)  /* From here need to work out if going up or down */
		{
			if (Current_Rot_Status == Phase_3)
				Keypress_Read = Rot_Up;
			else
				Keypress_Read = Rot_Down;
		}
		else if (Old_Rot_Status == Phase_3)  /* From here need to work out if going up or down */
		{
			if (Current_Rot_Status == Phase_0)
				Keypress_Read = Rot_Up;
			else
				Keypress_Read = Rot_Down;			
		}
	
		Slow_Loop_Counter = Slow_Counter_Init;	/* If key just pressed initialise slow counter */
	
		if (Fast_Loop_Counter > 0)
			Fast_Loop_Counter--;
	}
	else if (Key_Just_Pressed && (Current_Rot_Status & (Sel + Exit)))
	{
		if (Current_Rot_Status & Sel)
			Keypress_Read = Sel;			
		if (Current_Rot_Status & Exit)
			Keypress_Read = Exit;			
		Fast_Change = 1;
	}		
	else    /* else not Key_just_Pressed */
	{
		Keypress_Read = 0;
		if (Slow_Loop_Counter > 0)
			Slow_Loop_Counter--;
	}


	if (Slow_Loop_Counter == 0)
	{
		Fast_Change = 1;
		Fast_Loop_Counter = Fast_Counter_Init;
	}

	if (Fast_Loop_Counter == 0)   /* move into fast change of value for user */
	{
		Fast_Change = 10;
	}
			
	INTCONbits.TMR0IF = 0;
	Old_Rot_Status = Current_Rot_Status;   /*Record Rot Status to allow comparison next ISR loop */
}


void main(void) {
int BandTemp; 
char Update_Display = 1; 			/* Flag saying need to update display */
unsigned int Temp;   						/* define this globally as we can save stome storage this way */
unsigned int Sample_Rate = 48000; 	/* CD = 44100, Analog = 48000 */
unsigned char DAC_Atten = 0;      	/* literally the attenuation for the DAC, i.e. Volume Control */
char Auto_Repeat = 0;             	/* use this to keep track of whether a Auto Repeat button Press */
long int Auto_Revert = Auto_Revert_Init_Val;	
									/* Use this as a counter - after 255 loops auto revert to volume mode */
char Band = 0;           			/* use to drive state machine band select */
unsigned char Fn = 0;   			/* use to drive state machine function 
										initially set to crap value, then tidy up after display boot msg*/
int Step_Size = 0;        			/* Use this to implement push button steps */  
int Display_Value = Volume_Mode;  	/* use this to display the current value */
char Mode = Volume_Mode;			/* use this to track current mode */
char Memory_Bank = Default_Mem_Bank;/* use this to track which memory bank is in use */
char Sel_Fn = Choosing_Fn;			/* Use this to track current Selection */
char XO_Parm = XO_LF_Parm_Fn;		/* Default to XO_LF_Parm_Fn */
char EQ_Parm = Gen1_Para_data;		/* Default to General 1 parametric EQ */

/*Allows system to settle*/
DelayMs(200);

/* intitialise the Micro I/O ports*/
Init_IO();

/*Allows AD1940 to settle*/
DelayMs(200);


Init_LCD();				/* initialise the LCD */
Update_LCD();				/* Writes Line1 and Line2 to LCD */

Load_From_Memory(Memory_Bank); /* Read Data from ROM */
DAC_Atten = EEPROM_READ(Volume_Offset);   /* Volume */

Band = 0;				/* set this to a sensible value */
Data_Values_Pointer = &(Data_Values[Band]);
EQ_Values_Pointer = &(EQ_Values[Band]);

						/* Load Code into DSP  */
Init_DSP();
						/* Load Volume Setting */
Write_Dac_Atten(Mute);
						/* Load Filter Settings */

Update_Filter_Set(Sample_Rate);
						/* Load Attenuator Settings */
Update_Atten_Set();
						/* Load Delay Settings */
Update_Delay_Set(Sample_Rate);

						/* Load Volume Setting */
Write_Dac_Atten(DAC_Atten);

Fn = Lower_Freq_Hz_LED;	/* tidy up function variable now have displayed boot message */
/* display booting */
Display_Data(Band, Sel_Fn, Display_Value);

/*
State Machine that looks after user input

This will be an infinite loop that:
	- Looks at inputs
	- If one has changed, acts on it by
		- If band change input, updates band being changed.
			- Update Band_No
		- If Fn Select, updates funtion being changed 
			- Update Fn_Sel.  
		- If Value, then change value of Band_Sel -->> Fn_Sel, i.e. Band1 -->> B1L
		- If Save, writes current Band_No --> Fn_Sel value to EEPROM
		- If Volume
			- Changes Volume value
			- write value to EEPROM
	- Calls Display function, that once per cycle:
		- Displays Band_No
		- Displays Fn_Sel
		- Displays Val3
		- Displays Val2
		- Displays Val1
		- Displays Val0
*/





/****************************************************************************/	
/* This sets up the test ISR 												*/
/****************************************************************************/	
OpenTimer0 (TIMER_INT_ON & T0_SOURCE_INT & T0_8BIT & T0_PS_1_16);
INTCONbits.GIE = 1;


/* 
Buttons are: Mode_Sel, Fn_Sel, Vol_Dn, Vol_Up, Exit, Vals_0, Vals_1, Vals_2 
Watch what is done with them, and act as required
Band, Fn, Val
*/
do
{
/* Look after changing modes */
	if (Key_Just_Pressed)
	{
		Update_Display = 1;
		Auto_Revert = Auto_Revert_Init_Val;		/* If key pressed, reset the counter */

		/********************************************************************/
		/* Currently in Change Mode - act on legal button presses 			*/
		/********************************************************************/
		if (Sel_Fn == Choosing_Fn)
		{
			/* Up or Down*/
			if (Up_Keys || Down_Keys)
			{
				if (Up_Keys)
					Mode += 1;
				else
					Mode -= 1;
				/* check for wrap around */
				if (Mode > EQ_Mode)
					Mode = Volume_Mode;
				if (Mode < Volume_Mode)
					Mode = EQ_Mode;
			}

			/* Select Key hit */
			else if Sel_Key
			{
				Sel_Fn = Mode*10;
			}
			/* Exit */
			else if Exit_Key
			{
				Sel_Fn = Choosing_Fn;
			}
			
			else;
			
			if (Sel_Fn == Choosing_Fn)
				Display_Value = Mode;
			else if (Sel_Fn == Vol_Sel_Fn)
				Display_Value = 255 - DAC_Atten;
			else if (Sel_Fn == XO_Band_Sel_Fn)
				Display_Value = Band;
			else if (Sel_Fn == Save_Sel_Fn)
				Display_Value = Memory_Bank;
			else if (Sel_Fn == Load_Sel_Fn)
				Display_Value = Memory_Bank;
			else if (Sel_Fn == EQ_Sel_Fn)
				{
					Display_Value = Band_1_Para_data;  /* this is band 1 */
					EQ_Parm = Band_1_Para_data;
					Band = EQ_Parm;
				}
			else;

		}


		/********************************************************************/
		/* Currently in Volume Select Function - act on legal button presses*/
		/********************************************************************/
		else if (Sel_Fn == Vol_Sel_Fn)
		{
			/* Up */
			if Down_Keys
			{
				if (DAC_Atten < (unsigned char) (Volume_Atten_Max - Fast_Change)) 
				{
					DAC_Atten = DAC_Atten + Fast_Change;
					Write_Dac_Atten(DAC_Atten);
 				}	
				Display_Value = 255 - DAC_Atten;
			}
			/* Down */
			else if Up_Keys
			{
				if (DAC_Atten > (unsigned char)(Volume_Atten_Min + Fast_Change)) 
				{
					DAC_Atten = DAC_Atten - Fast_Change;
					Write_Dac_Atten(DAC_Atten);
 				}
				Display_Value = 256 - DAC_Atten;
			}
			else if (Keypress_Read == Exit)
			{
				Sel_Fn = Choosing_Fn;
				Display_Value = Mode;
			}
			else;
		}

		/************************************************************************/
		/* Currently in XO mode - look after key presses and function changes 	*/
		/************************************************************************/
		else if(Sel_Fn == XO_Band_Sel_Fn)
		{
			/*	This section works out which band the user wants to set 
				XO parameters for 											*/
			/* Up */
			if Up_Keys
			{
				if (Band < Max_Bands)
					Band += 1;
				else
					Band = 0;   /* always start from band zero */
				Display_Value = Band;
			}
			/* Down */
			else if Down_Keys
			{
				if (Band > 0)
					Band -= 1;
				else
					Band = Max_Bands;
				Display_Value = Band;
		}
			/* Select Key hit */
			else if Sel_Key
			{
				Sel_Fn = XO_Parm_Sel;
				XO_Parm = XO_LF_Parm_Fn;		/* Start at LF Parms */
				Display_Value = XO_Parm;
			}
			/* Exit */
			else if Exit_Key
			{
				Sel_Fn = Choosing_Fn;
				Display_Value = Mode;
			}
			else;
			/* Use pointer to Data_Values array to save code space 				*/
			/* Just don't go changing Band without updating this pointer!!! 	*/
			Data_Values_Pointer = &(Data_Values[Band]);
		}
			
		/************************************************************************/
		/* Currently in XO Parameter Select mode - look after key presses 
			and function changes 												*/
		/************************************************************************/
		else if(Sel_Fn == XO_Parm_Sel)
		{
			/*	This section works out which Parameter the user wants to set	*/ 
			/*	XO parameters for 												*/
			/* Up 																*/
			if Up_Keys
			{
				if (XO_Parm < XO_Att_Parm_Fn)
					XO_Parm += 1;
				else
					XO_Parm = XO_LF_Parm_Fn;   /* always start from XO_LF_Parm_Fn */
				Display_Value = XO_Parm;
			}
			/* Down */
			else if Down_Keys
			{
				if (XO_Parm > XO_LF_Parm_Fn)
					XO_Parm -= 1;
				else
					XO_Parm = XO_Att_Parm_Fn;	/* Jump it back up to Att Parm Fn */
				Display_Value = XO_Parm;
			}
			/* Select Key hit */
			else if Sel_Key
			{
				Sel_Fn = XO_Parm;
				if(Sel_Fn == XO_LF_Parm_Fn)
					Display_Value = Data_Values_Pointer->Fl;
				else if(Sel_Fn == XO_HF_Parm_Fn)
					Display_Value = Data_Values_Pointer->Fu;
				else if (Sel_Fn == XO_SL_Parm_Fn)
					Display_Value = Data_Values_Pointer->Sl;
				else if (Sel_Fn == XO_SU_Parm_Fn) 
					Display_Value = Data_Values_Pointer->Su;
				else if (Sel_Fn == XO_Del_Parm_Fn) 
					Display_Value =  Data_Values_Pointer->Delay_mm;
				else if (Sel_Fn == XO_Att_Parm_Fn) 
					Display_Value =  Data_Values_Pointer->Atten;
				else;
				}
			/* Exit */
			else if Exit_Key
			{
				Sel_Fn = XO_Band_Sel_Fn;
				Display_Value = Band;

			}
		}

		/************************************************************************/
		/* Low Frequency Crossover Parameters									*/
		/************************************************************************/
		else if(Sel_Fn == XO_LF_Parm_Fn)
		{
			/*	This section reads user input for low frequency 				*/
			/*		XO parameters for 											*/
			/* Up 																*/
			if Up_Keys
			{
				if (Fast_Change > 1)
					Step_Size = Fast_Change_Frequencies;
				else
					Step_Size = 10;
				Data_Values_Pointer->Fl = Data_Values_Pointer->Fl + Step_Size;
				if (Data_Values_Pointer->Fl > Fl_Max) Data_Values_Pointer->Fl = Fl_Max;
    			Write_Filter_Parm(0x10 + Band, Data_Values_Pointer->Fl, Data_Values_Pointer->Sl, Sample_Rate,0 ,0); 
				Display_Value = Data_Values_Pointer->Fl;
			}
			/* Down */
			else if Down_Keys
			{
				if (Fast_Change > 1)
					Step_Size = -Fast_Change_Frequencies;
				else
					Step_Size = -10;
				Data_Values_Pointer->Fl = Data_Values_Pointer->Fl + Step_Size;
				if (Data_Values_Pointer->Fl < Fl_Min) Data_Values_Pointer->Fl = Fl_Min;
		 		Write_Filter_Parm(0x10 + Band, Data_Values_Pointer->Fl, Data_Values_Pointer->Sl, Sample_Rate,0 ,0); 
				Display_Value = Data_Values_Pointer->Fl;
		}
			/* Select Key hit */
			else if Sel_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_HF_Parm_Fn;
				Display_Value = Data_Values_Pointer->Fu;
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_Parm_Sel;
			}
			else;
			

			if Exit_Key
				Display_Value = XO_Parm;
			else;

		}
		

		/************************************************************************/
		/* High Frequency Crossover Parameters									*/
		/************************************************************************/
		else if(Sel_Fn == XO_HF_Parm_Fn)
		{
			/*		This section reads user input for High frequency 			*/
			/*		XO parameters for 											*/
			/* Up 																*/
			if Up_Keys
			{
				if (Fast_Change > 1)
					Step_Size = Fast_Change_Frequencies;
				else
					Step_Size = 10;
				Data_Values_Pointer->Fu = Data_Values_Pointer->Fu + Step_Size;
				if (Data_Values_Pointer->Fu > Fu_Max) Data_Values_Pointer->Fu = Fu_Max;
			    Write_Filter_Parm(0x00 + Band, Data_Values_Pointer->Fu, Data_Values_Pointer->Su, Sample_Rate,0 ,0); 
				Display_Value = Data_Values_Pointer->Fu;
			}
			/* Down */
			else if Down_Keys
			{
				if (Fast_Change > 1)
					Step_Size = -Fast_Change_Frequencies;
				else
					Step_Size = -10;
				Data_Values_Pointer->Fu = Data_Values_Pointer->Fu + Step_Size;
				if (Data_Values_Pointer->Fu < Fu_Min) Data_Values_Pointer->Fu = Fu_Min;
			    Write_Filter_Parm(0x00 + Band, Data_Values_Pointer->Fu, Data_Values_Pointer->Su, Sample_Rate,0 ,0); 
				Display_Value = Data_Values_Pointer->Fu;
			}
			/* Select Key hit */
			else if Sel_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_SL_Parm_Fn;
				Display_Value = Data_Values_Pointer->Sl;
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_Parm_Sel;
			}

			if Exit_Key
				Display_Value = XO_Parm;
			else;

		}
		

		/************************************************************************/
		/* Low Frequency Crossover Slope										*/
		/************************************************************************/
		else if(Sel_Fn == XO_SL_Parm_Fn)
		{
			/*		This section reads user input for low frequency XO slope	*/
			/*		XO parameters for 											*/
			/* Up 																*/
			if Up_Keys
			{
				Step_Size = 1;
				Data_Values[Band].Sl += Step_Size;
				if (Data_Values_Pointer->Sl > Sl_Max) Data_Values_Pointer->Sl = Sl_Min;
   				Write_Filter_Parm(0x10 + Band, Data_Values_Pointer->Fl, Data_Values_Pointer->Sl, Sample_Rate,0 ,0); 
				Display_Value = Data_Values_Pointer->Sl;
			}
			/* Down */
			else if Down_Keys
			{
				Step_Size = 1;
				if (Data_Values_Pointer->Sl > Sl_Min) Data_Values_Pointer->Sl -= 1;
				else Data_Values_Pointer->Sl = Sl_Max;
				Write_Filter_Parm(0x10 + Band, Data_Values_Pointer->Fl, Data_Values_Pointer->Sl, Sample_Rate,0 ,0); 
				Display_Value = Data_Values_Pointer->Sl;
			}
			/* Select Key hit */
			else if Sel_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_SU_Parm_Fn;
				Display_Value = Data_Values_Pointer->Su;
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_Parm_Sel;
			}

			if Exit_Key
				Display_Value = XO_Parm;
			else;
		}
		

		/************************************************************************/
		/* High Frequency Crossover Slope										*/
		/************************************************************************/
		else if(Sel_Fn == XO_SU_Parm_Fn)
		{
			/*		This section reads user input for high frequency XO slope	*/
			/*		XO parameters for 											*/
			/* Up 																*/
			if Up_Keys
			{
				Step_Size = 1;
				Data_Values_Pointer->Su += Step_Size;
				if (Data_Values_Pointer->Su > Su_Max) Data_Values_Pointer->Su = Su_Min;
			    Write_Filter_Parm(0x00 + Band, Data_Values_Pointer->Fu, Data_Values_Pointer->Su, Sample_Rate,0 ,0); 
				Display_Value = Data_Values_Pointer->Su;
			}
			/* Down */
			else if Down_Keys
			{
				Step_Size = 1;
				if (Data_Values_Pointer->Su > Su_Min) Data_Values_Pointer->Su -= 1;
				else Data_Values_Pointer->Su = Su_Max;
			    Write_Filter_Parm(0x00 + Band, Data_Values_Pointer->Fu, Data_Values_Pointer->Su, Sample_Rate,0 ,0); 
				Display_Value = Data_Values_Pointer->Su;
			}
			/* Select Key hit */
			else if Sel_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_Del_Parm_Fn;
				Display_Value = Data_Values_Pointer->Delay_mm;
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_Parm_Sel;
			}

			if Exit_Key
				Display_Value = XO_Parm;
			else;

		}

		/************************************************************************/
		/* Delay for specific Crossover Band									*/
		/************************************************************************/
		else if(Sel_Fn == XO_Del_Parm_Fn)
		{
			/*		This section reads user input for delay for the band's		*/
			/*		XO parameters	 											*/
			/* Up 																*/
			if Up_Keys
			{
				if (Fast_Change > 1)
					Step_Size = Fast_Chane_Delays;
				else
					Step_Size = 3;
				Data_Values_Pointer->Delay_mm = Data_Values_Pointer->Delay_mm + Step_Size;
				if (Data_Values_Pointer->Delay_mm > Delay_mm_Max) Data_Values_Pointer->Delay_mm = Delay_mm_Max;
				Write_Delay(Band, Data_Values_Pointer->Delay_mm, Sample_Rate);
				Display_Value = Data_Values_Pointer->Delay_mm;
			}
			/* Down */
			else if Down_Keys
			{
				if (Fast_Change > 1)
					Step_Size = -Fast_Chane_Delays;
				else
					Step_Size = -3;
				Data_Values_Pointer->Delay_mm = Data_Values_Pointer->Delay_mm + Step_Size;
				if (Data_Values_Pointer->Delay_mm < Delay_mm_Min) Data_Values_Pointer->Delay_mm = Delay_mm_Min;
				Write_Delay(Band, Data_Values_Pointer->Delay_mm, Sample_Rate);
				Display_Value = Data_Values_Pointer->Delay_mm;
			}
			/* Select Key hit */
			else if Sel_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_Att_Parm_Fn;
				Display_Value = Data_Values_Pointer->Atten;
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_Parm_Sel;
			}

			if Exit_Key
				Display_Value = XO_Parm;
			else;

		}

		/************************************************************************/
		/* Crossover Attenuation for band										*/
		/************************************************************************/
		else if(Sel_Fn == XO_Att_Parm_Fn)
		{
			/*		This section reads user input for the band's attenuation for*/
			/*		XO parameters	 											*/
			/* Up 																*/		
			if Up_Keys
			{
				Step_Size = 1;
				Data_Values_Pointer->Atten += Step_Size;
				if (Data_Values_Pointer->Atten > Atten_Max) Data_Values_Pointer->Atten = Atten_Max;
				Write_Atten(Band, Data_Values_Pointer->Atten);
				Display_Value = Data_Values_Pointer->Atten;
			}
			/* Down */
			else if Down_Keys
			{
				Step_Size = 1;
				if (Data_Values_Pointer->Atten < Step_Size)
					Data_Values_Pointer->Atten = Atten_Min;				
				else
					Data_Values_Pointer->Atten -= Step_Size;				
				Write_Atten(Band, Data_Values_Pointer->Atten);
				Display_Value = Data_Values_Pointer->Atten;
			}
			/* Select Key hit */
			else if Sel_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_LF_Parm_Fn;
				if (Band < Max_Bands)
					Band += 1;
				else
					Band = 0;   /* always start from band zero */
				/* Use pointer to Data_Values array to save code space 			*/
				/* Just don't go changing Band without updating this pointer!!! */
				Data_Values_Pointer = &(Data_Values[Band]);
				Display_Value = Data_Values_Pointer->Fl;
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = XO_Parm_Sel;
			}
			
			if Exit_Key
				Display_Value = XO_Parm;
			else;
		}



		/************************************************************************/
		/* Currently in EQ mode - look after key presses and function changes 	*/
		/* This section chooses which Parametric EQ the user is to change       */
		/************************************************************************/
		else if(Sel_Fn == EQ_Sel_Fn)
		{
			/*	This section works out which band the user wants to set 
				EQ parameters for 											*/
			/* Up */
			if Up_Keys
			{
				if (EQ_Parm < Gen2_Para_data)
					EQ_Parm += 1;
				else
					EQ_Parm = Band_1_Para_data;   /* always start from band zero */
				Display_Value = EQ_Parm;
			}
			/* Down */
			else if Down_Keys
			{
				if (EQ_Parm > 0)
					EQ_Parm -= 1;
				else
					EQ_Parm = Gen2_Para_data;
				Display_Value = EQ_Parm;
			}
			/* Select Key hit */
			else if Sel_Key
			{
				Sel_Fn = EQ_Type_Sel_Fn;
				Band = EQ_Parm;
				/* Use pointer to Data_Values array to save code space 			*/
				/* Just don't go changing Band without updating this pointer!!! */
				EQ_Values_Pointer = &(EQ_Values[Band]);				
				Display_Value = EQ_Values_Pointer->Type;
			}
			/* Exit */
			else if Exit_Key
			{
				Sel_Fn = Choosing_Fn;
				Display_Value = Mode;
				Band = 0;
				/* Use pointer to Data_Values array to save code space 			*/
				/* Just don't go changing Band without updating this pointer!!! */
				Data_Values_Pointer = &(Data_Values[Band]);
			}
			else;
		}

			
		/************************************************************************/
		/* Parametric EQ Centre Frequency Select Fcuntion						*/
		/************************************************************************/
		else if(Sel_Fn == EQ_Freq_Sel_Fn)
		{
			/*	This section reads user input for centre frequency 				*/
			/*	XO parameters for Parametric EQ									*/
			/* Up 																*/
			if Up_Keys
			{
				if (Fast_Change > 1)
					Step_Size = Fast_Change_Frequencies;
				else
					Step_Size = 10;
				EQ_Values_Pointer->CF = EQ_Values_Pointer->CF + Step_Size;
				if (EQ_Values_Pointer->CF > EQ_Max) EQ_Values_Pointer->CF = EQ_Max;
    			Write_Filter_Parm(Band, EQ_Values_Pointer->CF, EQ_Values_Pointer->Type + 0x10, Sample_Rate,EQ_Values_Pointer->Q ,EQ_Values_Pointer->Gain); 
				Display_Value = EQ_Values_Pointer->CF;
			}
			/* Down */
			else if Down_Keys
			{
				if (Fast_Change > 1)
					Step_Size = -Fast_Change_Frequencies;
				else
					Step_Size = -10;
				EQ_Values_Pointer->CF = EQ_Values_Pointer->CF + Step_Size;
				if (EQ_Values_Pointer->CF < EQ_Min) EQ_Values_Pointer->CF = EQ_Min;
    			Write_Filter_Parm(Band, EQ_Values_Pointer->CF, EQ_Values_Pointer->Type + 0x10, Sample_Rate,EQ_Values_Pointer->Q ,EQ_Values_Pointer->Gain); 
				Display_Value = EQ_Values_Pointer->CF;
		}
			/* Select Key hit */
			else if Sel_Key
			{
				if (EQ_Values_Pointer->Type == HiShelf_EQ)
				{
					Step_Size = 0;  
					Sel_Fn = EQ_Type_Sel_Fn;
					EQ_Parm += 1;
					if (EQ_Parm > Gen2_Para_data)
						EQ_Parm = Band_1_Para_data;
					Band = EQ_Parm;
					/* Use pointer to Data_Values array to save code space 			*/
					/* Just don't go changing Band without updating this pointer!!! */
					EQ_Values_Pointer = &(EQ_Values[Band]);
					Display_Value = EQ_Values_Pointer->Type;
				}
				else
				{
					Step_Size = 0;
					Sel_Fn = EQ_Q_Sel_Fn;
					Display_Value = EQ_Values_Pointer->Q;
				}
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = EQ_Sel_Fn;
			}
			else;
			

			if Exit_Key
				Display_Value = EQ_Parm;
			else;
		}


		/************************************************************************/
		/* Parametric EQ Q Value Select Funtion									*/
		/* Note that Q is a signed char, scaled by 10,							*/
		/* Value of variable is -100 to 100, representing -10.0 to +10.0 		*/	
		/************************************************************************/
		else if(Sel_Fn == EQ_Q_Sel_Fn)
		{
			/*	This section reads user input for the Q value	 				*/
			/*	for Parametric EQ												*/
			/* Up 																*/
			if Up_Keys
			{
				Step_Size = Fast_Change;
				EQ_Values_Pointer->Q = EQ_Values_Pointer->Q + Step_Size;
				if (EQ_Values_Pointer->Q > EQ_Q_Max) EQ_Values_Pointer->Q = EQ_Q_Max;
    			Write_Filter_Parm(Band, EQ_Values_Pointer->CF, EQ_Values_Pointer->Type + 0x10, Sample_Rate,EQ_Values_Pointer->Q ,EQ_Values_Pointer->Gain); 
				Display_Value = EQ_Values_Pointer->Q;
			}
			/* Down */
			else if Down_Keys
			{
				Step_Size = -Fast_Change;				
				EQ_Values_Pointer->Q = EQ_Values_Pointer->Q + Step_Size;
				if (EQ_Values_Pointer->Q < EQ_Q_Min) EQ_Values_Pointer->Q = EQ_Q_Min;
    			Write_Filter_Parm(Band, EQ_Values_Pointer->CF, EQ_Values_Pointer->Type + 0x10, Sample_Rate,EQ_Values_Pointer->Q ,EQ_Values_Pointer->Gain); 
				Display_Value = EQ_Values_Pointer->Q;
		}
			/* Select Key hit */
			else if Sel_Key
			{
				Step_Size = 0;
				Sel_Fn = EQ_Gain_Sel_Fn;
				Display_Value = EQ_Values_Pointer->Gain;
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = EQ_Sel_Fn;
			}
			else;
			

			if Exit_Key
				Display_Value = EQ_Parm;
			else;
		}


		/************************************************************************/
		/* Parametric EQ Gain Value Select Funtion								*/
		/* Value in dB															*/
		/************************************************************************/
		else if(Sel_Fn == EQ_Gain_Sel_Fn)
		{
			/*	This section reads user input for the Gain value				*/
			/*	for Parametric EQ												*/
			/* Up 																*/
			if Up_Keys
			{
				Step_Size = 1;
				EQ_Values_Pointer->Gain = EQ_Values_Pointer->Gain + Step_Size;
				if (EQ_Values_Pointer->Gain > EQ_Gain_Max) EQ_Values_Pointer->Gain = EQ_Gain_Max;
    			Write_Filter_Parm(Band, EQ_Values_Pointer->CF, EQ_Values_Pointer->Type + 0x10, Sample_Rate,EQ_Values_Pointer->Q ,EQ_Values_Pointer->Gain); 
				Display_Value = EQ_Values_Pointer->Gain;
			}
			/* Down */
			else if Down_Keys
			{
				Step_Size = -1;
				EQ_Values_Pointer->Gain = EQ_Values_Pointer->Gain + Step_Size;
				if (EQ_Values_Pointer->Gain < EQ_Gain_Min) EQ_Values_Pointer->Gain = EQ_Gain_Min;
    			Write_Filter_Parm(Band, EQ_Values_Pointer->CF, EQ_Values_Pointer->Type + 0x10, Sample_Rate,EQ_Values_Pointer->Q ,EQ_Values_Pointer->Gain); 
				Display_Value = EQ_Values_Pointer->Gain;
		}
			/* Select Key hit */
			else if Sel_Key
			{
				Step_Size = 0;  
				Sel_Fn = EQ_Type_Sel_Fn;
				EQ_Parm += 1;
				if (EQ_Parm > Gen2_Para_data)
					EQ_Parm = Band_1_Para_data;
				Band = EQ_Parm;
				/* Use pointer to Data_Values array to save code space 			*/
				/* Just don't go changing Band without updating this pointer!!! */
				EQ_Values_Pointer = &(EQ_Values[Band]);
				Display_Value = EQ_Values_Pointer->Type;			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = EQ_Sel_Fn;
			}
			else;
			

			if Exit_Key
				Display_Value = EQ_Parm;
			else;
		}

		/************************************************************************/
		/* Parametric EQ Type Select Funtion									*/
		/************************************************************************/
		else if(Sel_Fn == EQ_Type_Sel_Fn)
		{
			/*	This section reads user input for the EQ Type Desired			*/
			/*	for Parametric EQ												*/
			/* Up 																*/
			if Up_Keys
			{
				Step_Size = 1;
				EQ_Values_Pointer->Type = EQ_Values_Pointer->Type + Step_Size;
				if (EQ_Values_Pointer->Type > HiShelf_EQ) EQ_Values_Pointer->Type = No_EQ;
    			Write_Filter_Parm(Band, EQ_Values_Pointer->CF, EQ_Values_Pointer->Type + 0x10, Sample_Rate,EQ_Values_Pointer->Q ,EQ_Values_Pointer->Gain); 
				Display_Value = EQ_Values_Pointer->Type;
			}
			/* Down */
			else if Down_Keys
			{
				Step_Size = -1;
				EQ_Values_Pointer->Type = EQ_Values_Pointer->Type + Step_Size;
				if (EQ_Values_Pointer->Type < No_EQ) EQ_Values_Pointer->Type = HiShelf_EQ;
    			Write_Filter_Parm(Band, EQ_Values_Pointer->CF, EQ_Values_Pointer->Type + 0x10, Sample_Rate,EQ_Values_Pointer->Q ,EQ_Values_Pointer->Gain); 
				Display_Value = EQ_Values_Pointer->Type;
		}
			/* Select Key hit */
			else if Sel_Key
			{
				if (EQ_Values_Pointer->Type == No_EQ)
				{
					Step_Size = 0;  
					Sel_Fn = EQ_Type_Sel_Fn;
					EQ_Parm += 1;
					if (EQ_Parm > Gen2_Para_data)
						EQ_Parm = Band_1_Para_data;
					Band = EQ_Parm;
					/* Use pointer to Data_Values array to save code space 			*/
					/* Just don't go changing Band without updating this pointer!!! */
					EQ_Values_Pointer = &(EQ_Values[Band]);
					Display_Value = EQ_Values_Pointer->Type;
				}
			else
				{
					Step_Size = 0;
					Sel_Fn = EQ_Freq_Sel_Fn;
					/* Use pointer to Data_Values array to save code space 			*/
					/* Just don't go changing Band without updating this pointer!!! */
					EQ_Values_Pointer = &(EQ_Values[Band]);
					Display_Value = EQ_Values_Pointer->CF;
				}
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = EQ_Sel_Fn;
			}
			else;

			if Exit_Key
				Display_Value = EQ_Parm;
			else;
		}



		/************************************************************************/
		/* Currently in SAVE Function, act on legal button presses				*/
		/************************************************************************/
		else if(Sel_Fn == Save_Sel_Fn)
		{
			/*		This section miplements the save function 					*/
			/* Up 																*/
			if Up_Keys
			{
				Memory_Bank += 1;
				if (Memory_Bank > Max_Mem_Banks)
					Memory_Bank = 0;
				Display_Value = Memory_Bank;
			}
			/* Down */
			else if Down_Keys
			{
				if (Memory_Bank == 0)
					Memory_Bank = Max_Mem_Banks;
				else
					Memory_Bank -= 1;
				Display_Value = Memory_Bank;
			}
			/* Select Key hit */
			else if Sel_Key
			{
				/********************************************************************/
				/*		Save the data 
																					*/
				/********************************************************************/		
				for (loop=0; loop < 4; loop++)
					{
						BandTemp = (loop*Band_Data_Array_Size) + (ParmSet_Array_Size * Memory_Bank);
						Data_Values_Pointer = &(Data_Values[loop]);
					/* lower Freq */
					EEPROM_WRITE((BandTemp + Fl_Offset), (char) (Data_Values_Pointer->Fl));
					DelayMs(5);
					EEPROM_WRITE((BandTemp + Fl_Offset + 1), (char) (Data_Values_Pointer->Fl / 256));
					DelayMs(5);
					/* Upper Freq*/
					EEPROM_WRITE((BandTemp + Fu_Offset), (char)(Data_Values_Pointer->Fu));
					DelayMs(5);
					EEPROM_WRITE((BandTemp + Fu_Offset + 1), (char)(Data_Values_Pointer->Fu / 256 ));
					DelayMs(5);
					/* Lower Slope */
					EEPROM_WRITE((BandTemp + Sl_Offset), Data_Values_Pointer->Sl);
					DelayMs(5);
					/* Upper Slope */
					EEPROM_WRITE((BandTemp + Su_Offset), Data_Values_Pointer->Su);
					DelayMs(5);
					/* Attenuation for band */
					EEPROM_WRITE((BandTemp + Atten_Offset), Data_Values_Pointer->Atten);
					DelayMs(5);
					/* Delay for band */
					EEPROM_WRITE((BandTemp + Delay_mm_Offset), (char) (Data_Values_Pointer->Delay_mm ));
					DelayMs(5);
					EEPROM_WRITE((BandTemp + Delay_mm_Offset + 1), (char) (Data_Values_Pointer->Delay_mm / 256));
					DelayMs(5);
									
					EQ_Values_Pointer = &(EQ_Values[loop]);	
					/* Parametric EQ Centre Freq */
					EEPROM_WRITE((BandTemp + Para_CF_Offset), (char) (EQ_Values_Pointer->CF));
					DelayMs(5);
	 				EEPROM_WRITE((BandTemp + Para_CF_Offset + 1), (char) (EQ_Values_Pointer->CF/256));
					DelayMs(5);
					/* Parametric EQ Q Value */
					EEPROM_WRITE((BandTemp + Para_Q_Offset), (char) (EQ_Values_Pointer->Q));
					DelayMs(5);
					/* Parametric EQ Gain */
					EEPROM_WRITE((BandTemp + Para_Gain_Offset), (char)(EQ_Values_Pointer->Gain));
					DelayMs(5);
					/* Parametric EQ Type */
					EEPROM_WRITE((BandTemp + Para_Type_Offset), (char)(EQ_Values_Pointer->Type));
					DelayMs(5);
					};

				/* Volume */			
				EEPROM_WRITE(Volume_Offset, DAC_Atten);
				DelayMs(5);
				
				/* Read Data for each Para Set from EEPROM */
				BandTemp = (Para_Gen_Base + Para_Parmset_Size * Memory_Bank);	

				EQ_Values_Pointer = &(EQ_Values[Gen1_Para_data]);
	
					/* Gen1 Parametric EQ Centre Freq */
				EEPROM_WRITE((BandTemp + Para_Gen1_CF_Offset), (char) (EQ_Values_Pointer->CF));
				EEPROM_WRITE((BandTemp + Para_Gen1_CF_Offset + 1), (char)(EQ_Values_Pointer->CF/256));
				/* Gen1 Parametric EQ Q Value */
				EEPROM_WRITE((BandTemp + Para_Gen1_Q_Offset), (char)(EQ_Values_Pointer->Q));
				/* Gen1 Parametric EQ Gain */
				EEPROM_WRITE((BandTemp + Para_Gen1_Gain_Offset), (char)(EQ_Values_Pointer->Gain));
				/* Gen1 Parametric EQ Type */
				EEPROM_WRITE((BandTemp + Para_Gen1_Type_Offset), (char)(EQ_Values_Pointer->Type));

				EQ_Values_Pointer = &(EQ_Values[Gen2_Para_data]);
				/* Gen2 Parametric EQ Centre Freq */
				EEPROM_WRITE((BandTemp + Para_Gen2_CF_Offset), (char)(EQ_Values_Pointer->CF));
				EEPROM_WRITE((BandTemp + Para_Gen2_CF_Offset + 1), (char)(EQ_Values_Pointer->CF/256));
				/* Gen1 Parametric EQ Q Value */
				EEPROM_WRITE((BandTemp + Para_Gen2_Q_Offset), (char)(EQ_Values_Pointer->Q));
				/* Gen1 Parametric EQ Gain */
				EEPROM_WRITE((BandTemp + Para_Gen2_Gain_Offset), (char)(EQ_Values_Pointer->Gain));
				/* Gen1 Parametric EQ Type */
				EEPROM_WRITE((BandTemp + Para_Gen2_Type_Offset), (char)(EQ_Values_Pointer->Type));

				Sel_Fn = Choosing_Fn;
				Mode = Volume_Mode;
				Display_Value = Mode;
			}
			/* Exit */
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = Choosing_Fn;
				Mode = Volume_Mode;
				Display_Value = Mode;
			}
			else;
		}

		/************************************************************************/
		/* Currently in LOAD Function, act on legal button presses 				*/
		/************************************************************************/
		else if(Sel_Fn == Load_Sel_Fn)
		{
			/********************************************************************/
			/*		This section miplements the load data function 				*/
			/********************************************************************/
			/* Up */
			if Up_Keys
			{
				Memory_Bank += 1;
				if (Memory_Bank > Max_Mem_Banks)
					Memory_Bank = 0;
				Display_Value = Memory_Bank;
			}
			/* Down */
			else if Down_Keys
			{
				if (Memory_Bank == 0)
					Memory_Bank = Max_Mem_Banks;
				else
					Memory_Bank -= 1;
				Display_Value = Memory_Bank;
			}
			/* Select Key hit */
			else if Sel_Key
			{
				/********************************************************************/
				/*		Load the data 												*/
				/********************************************************************/		
				Load_From_Memory(Memory_Bank); /* Read Data from ROM */

				Sel_Fn = Choosing_Fn;
				Display_Value = Mode;
			}

		/************************************************************************/
		/* Exit 																*/
		/************************************************************************/
			else if Exit_Key
			{
				Step_Size = 0;
				Sel_Fn = Choosing_Fn;
				Display_Value = Mode;
			}
			
			else
				Update_Display = 0;
		}
	
		if (Update_Display)	
			Display_Data(Band, Sel_Fn, Display_Value);
		else;


	}  /* Done changing values for the user */


	/* Clears the flag saying that the push button press has been addressed */
	Step_Size = 0;



	Auto_Revert = Auto_Revert - 1;   				/* If no key pressed, then decrement this counter */
	if 	(Auto_Revert == 0)   						/* Then force the system to volume mode */
		{
			Auto_Revert = Auto_Revert_Init_Val;		/* If key pressed, reset the counter */
			Band = 0;
			Sel_Fn = Vol_Sel_Fn;
			Display_Value = 255 - DAC_Atten;
			Display_Data(Band, Sel_Fn, Display_Value);
			Display_Data(Band, Sel_Fn, Display_Value);
		}
		

	/* Read the Analog / CD bit and set the sample rate to the appropriate Value */
	Temp = Sample_Rate;
	if (Analog_CD_L_In)
		Sample_Rate = 44100;
	else
		Sample_Rate = 48000;
			
	if (Temp != Sample_Rate)  /* Then something has changed, and we need to update filter settings! */
		{
		Update_Filter_Set(Sample_Rate);
		}

	}
while (1);
}
